<?php

namespace Drupal\content_lock_timeout_test;

use Drupal\Component\Datetime\Time;

/**
 * This is a datetime.time service for testing only.
 *
 * @package Drupal\Tests\content_lock_timeout\Functional
 */
class TimeChanger extends Time {

  /**
   * {@inheritdoc}
   */
  public function getCurrentTime() {
    $time = \Drupal::keyValue('time')->get('time');
    if (!empty($time)) {
      return $time;
    }
    return parent::getCurrentTime();
  }

  /**
   * Forward current time to the given timestamp.
   *
   * @param int $time
   *   New time to set.
   */
  public function setCurrentTime(int $time): void {
    \Drupal::keyValue('time')->set('time', $time);
  }

  /**
   * Reset the current time to the real time.
   */
  public function resetCurrentTime(): void {
    \Drupal::keyValue('time')->delete('time');
  }

  /**
   * {@inheritdoc}
   */
  public function getRequestTime(): int {
    $time = \Drupal::keyValue('time')->get('time');
    if (!empty($time)) {
      return $time;
    }
    return parent::getRequestTime();
  }

}
